def solve_n_queens(n):
    def possible(board, row, col):
        # Vérifie si la colonne est sûre
        for i in range(row):
            if board[i] == col:
                return False

        # Vérifie la diagonale supérieure gauche
        for i, j in zip(range(row-1, -1, -1), range(col-1, -1, -1)):
            if board[i] == j:
                return False

        # Vérifie la diagonale supérieure droite
        for i, j in zip(range(row-1, -1, -1), range(col+1, n)):
            if board[i] == j:
                return False

        return True

    def backtrack(board, row):
        # Si nous avons placé toutes les reines, nous avons trouvé une solution valide
        if row == n:
            return True

        # Essayez de placer une reine dans chaque colonne de cette rangée
        for col in range(n):
            if possible(board, row, col):
                board[row] = col
                if backtrack(board, row+1):
                    return True
                board[row] = -1

        # Si nous n'avons pas trouvé de solution valide, retourner False
        return False

    # Initialise le tableau avec des valeurs nulles
    board = [-1] * n

    # Appel à la fonction backtrack pour trouver une solution
    if not backtrack(board, 0):
        print("Pas de solution")
        return None

    # Affiche la solution
    print("Solution trouvée pour",n,"reines :")
    for row in range(n):
        line = ""
        for col in range(n):
            if board[row] == col:
                line += "Q "
            else:
                line += ". "
        print(line)

    return board

# Exemple d'utilisation
solve_n_queens(6)
solve_n_queens(8)
solve_n_queens(12)