from classeEchiquier import *
import datetime
import random

def main():
    taille = int(input("Bienvenue dans le jeu des 8 reines !\nEntrez la taille de l'échiquier (maximum 10 pour une éxécution instantanée) : "))
    placement = input("Voulez-vous placer la première reine sur l'échiquier ? (O/N) : ")
    if placement == "O" or placement == "o":
        x = int(input(f"Sur quelle colonne voulez-vous placer la première reine (1-{taille}) ? : "))-1
        y = int(input(f"Sur quelle ligne voulez-vous placer la première reine (1-{taille}) ? : "))-1
    else:
        x = None
        y = None
    echiquier = Echiquier(taille)
    temps_execution = datetime.datetime.now()
    echiquier.resoudre()

    temps_execution = (datetime.datetime.now() - temps_execution).total_seconds()

    if len(echiquier.solutions) > 0: 
        print("Voici les solutions :")
        if x is not None and y is not None:
            """
            On affiche seulement les solutions où la première reine est placée à la position choisie par l'utilisateur
            On utilise la même méthode que dans la classe Echiquier pour afficher les solutions
            """
            solutions_avec_premiere_reine = []
            """
            maintenant on vérifie si la première reine est placée à la position choisie par l'utilisateur 
            en parcourant les échiquiers de la liste des solutions"""

            for solution in echiquier.solutions:
                if solution[y][x] == 1:
                    solutions_avec_premiere_reine.append(solution)

            for solution in solutions_avec_premiere_reine:
                for ligne in solution:
                    print(' '.join('R' if case == 1 else '.' for case in ligne))
                print("")
            
            print(f"Temps d'exécution : {temps_execution:.4f} seconde(s)")
            print(f"Nombre total de solutions avec le positionnement de la première reine choisie : {len(solutions_avec_premiere_reine)}")
        else:
            echiquier.afficher_solutions()

            print(f"Temps d'exécution : {temps_execution:.4f} seconde(s)") 
            print(f"Nombre total de solutions : {len(echiquier.solutions)}")
    else:
        print(f"Aucune solution trouvée pour {taille} reines.")
    
    menu(echiquier, x, y)

def menu(echiquier, x, y):
    choix = input("\nQue voulez-vous faire ?\n1. Essayer avec une autre taille d'échiquier\n2. Afficher les solutions en mode graphique\n3. Essayer avec une taille d'échiquier aléatoire\n4. Quitter\nVotre choix : ")
    if choix == "1":
        main()
    elif choix == "2":
        if x is not None and y is not None:
            echiquier.afficher_solutions_graphique_donnees([solution for solution in echiquier.solutions if solution[y][x] == 1])
        else:
            echiquier.afficher_solutions_graphique()
        menu(echiquier, x, y)
    elif choix == "3":
        taille = random.randint(1, 10) # on choisit une taille aléatoire entre 1 et 10 pour une exécution instantanée
        echiquier = Echiquier(taille)
        echiquier.temps_execution = datetime.datetime.now()
        echiquier.resoudre()

        temps_execution = (datetime.datetime.now() - echiquier.temps_execution).total_seconds()


        if len(echiquier.solutions) > 0:
            print("Voici les solutions :")
            echiquier.afficher_solutions()

            print(f"Temps d'exécution : {temps_execution:.4f} seconde(s") 
            print(f"Nombre total de solutions : {len(echiquier.solutions)}")
        else:
            print("Aucune solution trouvée.")
        
        menu(echiquier, x, y)
    elif choix == "4":
        print("Merci d'avoir joué !")
        exit()

main()